function [A, b] = discretize_poisson(grid, fun)

stencil_names = 'TRBL';

np = grid.np;
h  = grid.h;

A = sparse(np, np);
b = zeros(np, 1);

for i = 1:np
   mu = 1/h^2;

   for dir = 1:4
      if( grid.TRBL(dir, i)~=0 )
         A(i,grid.TRBL(dir, i)) = mu;
      end
   end

   A(i,i) = -4*mu;

   b(i) = -feval(fun, grid.x(:, i));
end

